import re
import os

class PromptPartNotFoundException(Exception):
    def __init__(self, path_to_file):
        message = f"File {path_to_file} was not found."
        super().__init__()

class PromptProvider:
    prompts = []

    def __init__(self, prompt_list):
        self.prompts = prompt_list
    
    @staticmethod
    def __replace_tag_with_file_contents_funcgenerator(end_folder):
        def replace_tag_with_file_contents_sub(re_match_obj):
            match = re_match_obj.group(1).lower()
            match_patch = f"{end_folder}/{match}.txt"
            if not os.path.exists(match_patch):
                raise PromptPartNotFoundExceptio(match_patch)
            with open(match_patch, 'r', encoding='utf-8') as file:
                return file.read().strip()
        return replace_tag_with_file_contents_sub

    def generate_prompts_for_folder(self, end_folder):
        finished_list_of_prompts = []
        for prompt in self.prompts:
            finished_prompt = re.sub('\[\[\s*(.*?)\s*\]\]', self.__replace_tag_with_file_contents_funcgenerator(end_folder), prompt)
            finished_list_of_prompts.append(finished_prompt)
        return finished_list_of_prompts
